#include <stdio.h>
#include "ss.h"
#include <stdlib.h>
#include <unistd.h>

//typedef unsigned char uint8_t;

#include "i2cdev.h"

const int port_base = 11845;
static SOCKETIO *ssp,*csp;

void i2cdev_init( uint8_t myaddress) {
	ssp = ServerSock(port_base + myaddress);
	if (!ssp) {
		fprintf(stderr,"open server socket port %d\n",port_base+myaddress);
		exit(1);
	}
	fprintf(stderr,"waiting connection ...");
	fflush(stderr);
	csp = AcceptSock(ssp);
	if (!csp) {
		fprintf(stderr,"error\n");
		exit(1);
	}
	fprintf(stderr,"done\n");
}

static uint8_t in_buf[256];
int in_buf_len = 0;
int in_buf_ptr = 0;

static void read_sub(int w) {
	char buf[4096];
	int in_buf_i[256];
	int i,r;
retry:
	if (!SockGets(buf,4096,csp)) {
		exit(0);
	}
	r = sscanf(buf,"%02x %02x %02x %02x %02x %02x %02x"
			,in_buf_i,in_buf_i+1,in_buf_i+2,in_buf_i+3
			,in_buf_i+4,in_buf_i+5,in_buf_i+6,in_buf_i+7);
	if (r < 0) {
		fprintf(stderr,"sscanf error\n");
		exit(1);
	}
	for (i=0 ;i<r; i++) {
		in_buf[i] = in_buf_i[i];
	}
	in_buf_len = r;
	in_buf_ptr = 0;
	if (w && (r == 0)) goto retry;
}

uint8_t i2cdev_can_getc(uint8_t n) {
	if (in_buf_len && (in_buf_len != in_buf_ptr))
		return ( in_buf_len - in_buf_ptr >= n);
	if (SockSelect((double)0.05, NULL)) {
		read_sub(0);
		return (in_buf_len >= n);
	}
	return 0;
}

uint8_t i2cdev_getc() {
	uint8_t c;
	if (i2cdev_can_getc(1)) {
		c = in_buf[in_buf_ptr++];
		return c;
	}
	read_sub(1);
	c = in_buf[in_buf_ptr++];
	return c;
}

void i2cdev_flush() {
	in_buf_ptr = in_buf_len = 0;
}

void i2cdev_putc(uint8_t c) {
}

//extern uint8_t i2cdev_can_putc( uint8_t );
//extern void i2cdev_putc( uint8_t data );
